3 # © 2023 Lady [@ Lady’s Computer].
5 # This Source Code Form is subject to the terms of the Mozilla Public
6 # License, v. 2.0. If a copy of the MPL was not distributed with this
7 # file, You can obtain one at https://mozilla.org/MPL/2.0/.
10 BEORN = https://git.ladys.computer/Beorn/blob_plain/$(BEORN_VERSION):/build.js
12 # This Makefile requires rsync 3 or newer.
14 RSYNC_FLAGS = -Oclmrtvz
16 RSYNC_FILTER = .rsync-filter
18 SOURCE_CHARSET = utf-8-mac
20 DESTINATION_HOST = computer
21 DESTINATION_PATH = lady/www
22 DESTINATION = $(DESTINATION_HOST):$(DESTINATION_PATH)
23 DESTINATION_CHARSET = utf-8
26 SOURCE_CHARSET = utf-8-mac
27 DESTINATION_CHARSET = utf-8
28 DESTINATION_HOST = computer
29 DESTINATION_PATH = lady/blog
30 DESTINATION = $(DESTINATION_HOST):$(DESTINATION_PATH)
33 deno run --allow-read=. --allow-write=. $(BEORN)
37 @if [ ! -f .grass ]; then echo 'Error: The website has not been built yet!' >&2; echo 'Run `make` before syncing.' >&2; exit 1; fi
38 @if buildtime=$$(stat -f '%m' .grass) && committime=$$(git log -1 --format='%ct' | awk '{print $$NF}') && [ "$$committime" -gt "$$buildtime" ]; then echo 'Error: A commit was made after the last build!' >&2; echo 'Run `make` before syncing.' >&2; exit 1; fi
40 ensure-branch-up-to-date:
42 @if ! git merge-base --is-ancestor @{u} HEAD; then echo 'Error: This branch is currently out‐of‐date!' >&2; echo 'Pull in changes with `git pull` before syncing.' >&2; exit 1; fi
45 @if output=$$(git status --porcelain) && [ ! -z "$$output" ]; then echo 'Error: There are uncommitted changes!' >&2; echo 'Commit changes and run `make` before syncing.' >&2; exit 1; fi
46 @if output=$$(git status --porcelain) && [ ! -z "$$output" ]; then echo 'Error: There are uncommitted changes!' >&2; echo 'Commit changes and run `make` before syncing.' >&2; exit 1; fi
48 dry-sync: ensure-clean ensure-branch-up-to-date ensure-build
49 $(RSYNC) $(RSYNC_FLAGS) --del --dry-run --filter=". $(RSYNC_FILTER)" --iconv=$(SOURCE_CHARSET),$(DESTINATION_CHARSET) $(RSYNC_OPTIONS) . $(DESTINATION)
51 sync: ensure-clean ensure-branch-up-to-date ensure-build
52 $(RSYNC) $(RSYNC_FLAGS) --del --filter=". $(RSYNC_FILTER)" --iconv=$(SOURCE_CHARSET),$(DESTINATION_CHARSET) $(RSYNC_OPTIONS) . $(DESTINATION)
55 .PHONY: build dry-sync ensure-branch-up-to-date ensure-build ensure-clean sync;